"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    Object.defineProperty(o, k2, { enumerable: true, get: function() { return m[k]; } });
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const swc = __importStar(require("@swc/core"));
const lodash_merge_1 = __importDefault(require("lodash.merge"));
const react_refresh_helper_1 = require("./react-refresh-helper");
const ReactRefreshBoundaryCollector_1 = __importDefault(require("./ReactRefreshBoundaryCollector"));
function swcReact(options = {}) {
    const { reactFresh = true, swcOptions = {}, jsxRuntime = 'automatic', } = options;
    let isDevelopment = false;
    return [
        {
            name: 'vite-plugin-swc-react',
            enforce: 'pre',
            config(_config, env) {
                isDevelopment = env.mode === 'development';
            },
            transformIndexHtml() {
                if (isDevelopment && reactFresh) {
                    return [
                        {
                            tag: 'script',
                            attrs: { type: 'module' },
                            children: react_refresh_helper_1.reactRefreshRuntimeCode,
                        },
                    ];
                }
            },
            transform(code, id) {
                return __awaiter(this, void 0, void 0, function* () {
                    if (/\.(js|[tj]sx?)$/.test(id)) {
                        let isTypescript = ['.ts', '.tsx'].some((p) => id.endsWith(p));
                        let is_SX = ['.jsx', '.tsx'].some((p) => id.endsWith(p));
                        const collector = new ReactRefreshBoundaryCollector_1.default();
                        const resolveSWCOptions = (0, lodash_merge_1.default)(Object.assign(Object.assign(Object.assign({}, (isDevelopment && is_SX
                            ? {
                                plugin: swc.plugins([(p) => collector.visitProgram(p)]),
                            }
                            : {})), { filename: id, env: {
                                // copied from https://vitejs.dev/guide/build.html
                                targets: 'defaults and supports es6-module and supports es6-module-dynamic-import, not opera > 0, not samsung > 0, not and_qq > 0',
                                mode: 'usage',
                                coreJs: 3,
                            }, jsc: {
                                parser: isTypescript
                                    ? {
                                        syntax: 'typescript',
                                        tsx: is_SX,
                                    }
                                    : {
                                        syntax: 'ecmascript',
                                        jsx: is_SX,
                                    },
                                transform: {
                                    react: {
                                        development: isDevelopment,
                                        runtime: jsxRuntime,
                                        refresh: reactFresh,
                                    },
                                },
                            } }), swcOptions), swcOptions);
                        const transformed = yield swc.transform(code, resolveSWCOptions);
                        return Object.assign(Object.assign({}, transformed), { code: isDevelopment && reactFresh
                                ? (0, react_refresh_helper_1.addReactFreshWrapper)(id, transformed.code, collector.isReactRefreshBoundary) // FIXME: better checking for isReactRefreshBoundary
                                : transformed.code });
                    }
                });
            },
        },
    ];
}
exports.default = swcReact;
